/*
Copyright © 2021 NAME HERE <EMAIL ADDRESS>

*/
package cmd

import (
	"fmt"

	"github.com/spf13/cobra"
)

// addCmd represents the add command
var addCmd = &cobra.Command{
	Use:   "add [entry title]",
	Args:  cobra.ExactArgs(1),
	Short: "Add a new diary entry with the given title",
	Long: `Add a new diary entry, for example
and usage of using your command. For example:

$ diary add "Issue when fixing bad data in prod"
1134

The returned number is the ID of the added entry.
This ID can be used in other commands.
`,
	Run: func(cmd *cobra.Command, args []string) {
		var entry = App.NewDiaryEntry(args[0])
		fmt.Println(entry.Id)
	},
}

func init() {
	rootCmd.AddCommand(addCmd)

	// Here you will define your flags and configuration settings.

	// Cobra supports Persistent Flags which will work for this command
	// and all subcommands, e.g.:
	// addCmd.PersistentFlags().String("foo", "", "A help for foo")

	// Cobra supports local flags which will only run when this command
	// is called directly, e.g.:
	// addCmd.Flags().BoolP("toggle", "t", false, "Help message for toggle")
}
