/*
Copyright © 2021 NAME HERE <EMAIL ADDRESS>

*/
package cmd

import (
	"io/ioutil"
	"log"
	"os"
	"strconv"

	"github.com/spf13/cobra"
)

// editNoteCmd represents the editNote command
var editNoteCmd = &cobra.Command{
	Use:   "note",
	Args:  cobra.ExactArgs(1),
	Short: "A brief description of your command",
	Long: `A longer description that spans multiple lines and likely contains examples
and usage of using your command. For example:

Cobra is a CLI library for Go that empowers applications.
This application is a tool to generate the needed files
to quickly create a Cobra application.`,
	PreRunE: func(cmd *cobra.Command, args []string) error {
		id, err := strconv.Atoi(args[0])
		if err != nil {
			return err
		}
		_, err = App.GetDiaryEntryNote(int64(id))
		if err != nil {
			return err
		}
		return nil
	},
	Run: func(cmd *cobra.Command, args []string) {
		id, _ := strconv.Atoi(args[0])
		note, _ := App.GetDiaryEntryNote(int64(id))
		temp_file, err := ioutil.TempFile(os.TempDir(), "diary_note.*.md")
		if err != nil {
			log.Fatal(err)
		}

		// Preload the data in the file
		_, err = temp_file.Write([]byte(note.Body))
		if err != nil {
			log.Fatal(err)
		}

		err = OpenEditor(temp_file.Name())
		if err != nil {
			log.Fatal(err)
		}
		new_content, err := ioutil.ReadFile(temp_file.Name())
		if err != nil {
			log.Fatal(err)
		}
		App.EditDiaryEntryNote(note.Id, string(new_content))
	},
}

func init() {
	editCmd.AddCommand(editNoteCmd)

	// Here you will define your flags and configuration settings.

	// Cobra supports Persistent Flags which will work for this command
	// and all subcommands, e.g.:
	// editNoteCmd.PersistentFlags().String("foo", "", "A help for foo")

	// Cobra supports local flags which will only run when this command
	// is called directly, e.g.:
	// editNoteCmd.Flags().BoolP("toggle", "t", false, "Help message for toggle")
}
